#include "at_command.h"

#include <unistd.h>

static char cmd_buffer[CMD_BUFFER_SIZE] = {0};
static int cmd_indx = 0;

Ciss_data_struct m_dev;

UCHAR convert_string_2_hex8(CHAR* ascii)
{
	UCHAR r = 0;
	SHORT i = 0;

	for(i=0; i<2; i++)
	{
		if((ascii[i] >='a') && (ascii[i] <='z'))
		{
			ascii[i] -= 0x20;
		}
	}

	r = (ascii[0]>'9') ? (ascii[0] - 'A' + 10) : (ascii[0] - '0');
	r <<= 4;

	r += (ascii[1]>'9') ? (ascii[1] - 'A' + 10) : (ascii[1] - '0');

	return r;
}

SHORT convert_string_2_hex16(CHAR* ascii)
{
	SHORT r = 0;
	SHORT i = 0;


	for(i=0; i<4; i++)
	{
		if((ascii[i] >='a') && (ascii[i] <='z'))
		{
			ascii[i] -= 0x20;
		}

		r += (ascii[i]>'9') ? (ascii[i] - 'A' + 10) : (ascii[i] - '0');

		if(i<3)
			r <<= 4;
	}

	return r;
}



UINT convert_string_2_hex32(CHAR* ascii)
{
	UINT r = 0;
	SHORT i = 0;

	for(i=0; i<8; i++)
	{
		if((ascii[i] >='a') && (ascii[i] <='z'))
		{
			ascii[i] -= 0x20;
		}

		r += (ascii[i]>'9') ? (ascii[i] - 'A' + 10) : (ascii[i] - '0');

		if(i<7)
			r <<= 4;
	}

	return r;
}


static void at_cmd_get_value(char*buf, int len, int x, char* desBuf, int l)
{
	int i = 0;
	int inx = 0;
	int j = 0;
	int k = 0;

	for(j=0; j<len; j++)	///find the = char
	{
		if(buf[j] == '=')
		{
			j++;
			break;
		}

	}
	////find the , char positon
	for(i=j; i<len; i++)
	{
		if(inx == x)
		{
			if(k >= l)
			{
				break;
			}
			else
			{
				desBuf[k++] = buf[i];
			}

		}
		else
		{
			if(buf[i] == ',')
			{
				inx++;
			}
		}
	}
}

extern void Ciss_data_post(POST_DATA_TYPE_ENUM typ);

static void at_cmd_DT(char*buf, int len)
{
	CHAR macAddr[16] ={0};
	CHAR Value[5] ={0};

	printf("process cmd DT =%d !\r\n", len);


	at_cmd_get_value(buf, len, 0, macAddr, 12);
	memcpy(m_dev.dev_sn, macAddr, 12);

	/////acc xyz
	at_cmd_get_value(buf, len, 1, Value, 4);
	m_dev.motion_data.Acc_x = convert_string_2_hex16(Value);
	at_cmd_get_value(buf, len, 2, Value, 4);
	m_dev.motion_data.Acc_y = convert_string_2_hex16(Value);
	at_cmd_get_value(buf, len, 3, Value, 4);
	m_dev.motion_data.Acc_z = convert_string_2_hex16(Value);


	/////gro xyz
	at_cmd_get_value(buf, len, 4, Value, 4);
	m_dev.motion_data.Gro_x = convert_string_2_hex16(Value);
	at_cmd_get_value(buf, len, 5, Value, 4);
	m_dev.motion_data.Gro_y = convert_string_2_hex16(Value);
	at_cmd_get_value(buf, len, 6, Value, 4);
	m_dev.motion_data.Gro_z = convert_string_2_hex16(Value);

	/////mag xyz
	at_cmd_get_value(buf, len, 7, Value, 4);
	m_dev.motion_data.Mag_x = convert_string_2_hex16(Value);
	at_cmd_get_value(buf, len, 8, Value, 4);
	m_dev.motion_data.Mag_y = convert_string_2_hex16(Value);
	at_cmd_get_value(buf, len, 9, Value, 4);
	m_dev.motion_data.Mag_z = convert_string_2_hex16(Value);

/*
	printf("dev sn = %s  ",m_dev.dev_sn);
	printf("motion data  acc x= %d, y=%d, z=%d   ", m_dev.motion_data.Acc_x,
			m_dev.motion_data.Acc_y, m_dev.motion_data.Acc_z);
	printf("gro x= %d, y=%d, z=%d   ", m_dev.motion_data.Gro_x,
				m_dev.motion_data.Gro_y, m_dev.motion_data.Gro_z);
	printf("mag x= %d, y=%d, z=%d   \r\n", m_dev.motion_data.Mag_x,
					m_dev.motion_data.Mag_y, m_dev.motion_data.Mag_z);
*/
	Ciss_data_post(POST_DATA_MOTION);
}

static void at_cmd_VT(char*buf, int len)
{
	CHAR macAddr[16] ={0};
	CHAR Value[5] ={0};
	CHAR ValueM[9] ={0};
	/////&ET=02891B550346,00ed,114d,00018f00,00ed,00018f00
	printf("process cmd vT =%d !\r\n", len);
	at_cmd_get_value(buf, len, 0, macAddr, 12);
	memcpy(m_dev.dev_sn, macAddr, 12);
	/////temprature
	at_cmd_get_value(buf, len, 1, Value, 4);
	m_dev.evr_data.temp = convert_string_2_hex16(Value);
	/////humid
	at_cmd_get_value(buf, len, 2, Value, 4);
	m_dev.evr_data.humid = convert_string_2_hex16(Value);
	////pressure
	at_cmd_get_value(buf, len, 3, ValueM, 8);
	m_dev.evr_data.pressure = convert_string_2_hex32(ValueM);
	////noise
	at_cmd_get_value(buf, len, 4, Value, 4);
	m_dev.evr_data.noise = convert_string_2_hex16(Value);
	////light
	at_cmd_get_value(buf, len, 5, ValueM, 8);
	m_dev.evr_data.light = convert_string_2_hex32(ValueM);
/*
	printf("devv sn = %s  ",m_dev.dev_sn);
	printf("motion data  temp=%d, humid=%d, pressure = %d   ", m_dev.evr_data.temp,
			m_dev.evr_data.humid, m_dev.evr_data.pressure);
	printf("noise= %d, light=%d  \r\n", m_dev.evr_data.noise,
				m_dev.evr_data.light);
*/
	Ciss_data_post(POST_DATA_EVIRMENT);
}

static void at_cmd_CN(char*buf, int len)
{
	CHAR Value[5] ={0};
	UCHAR byt = 0;
	at_cmd_get_value(buf, len, 0, Value, 2);
	byt = convert_string_2_hex8(Value);
	printf("process cmd CN =%d!\r\n", byt);
	if(byt == 0x00)
	{
		printf("process cmd CONNECTED!\r\n");
		m_dev.dev_state = STATE_CONNECTED;
		Ciss_ble_evt_post(EVT_CONNECT_SUCCESS);
	}
	else
	{
		m_dev.dev_state = STATE_IDLE;
		printf("process cmd CONNECT FAIL!\r\n");
		Ciss_ble_evt_post(EVT_CONNECT_FAIL);
	}
}

static void at_cmd_IT(char*buf, int len)
{
	CHAR Value[5] ={0};
	UCHAR byt = 0;
	at_cmd_get_value(buf, len, 0, Value, 2);
	byt = convert_string_2_hex8(Value);
	if(byt == 0x00)
	{
		printf("process cmd IT ON!\r\n");
		m_dev.dev_state = STATE_CH_IT_OPEN;
		Ciss_ble_evt_post(EVT_OPEN_IT_CH);
	}
	else
	{
		m_dev.dev_state = STATE_IDLE;
	}
}

static void at_cmd_ET(char*buf, int len)
{
	CHAR Value[5] ={0};
	UCHAR byt = 0;
	at_cmd_get_value(buf, len, 0, Value, 2);
	byt = convert_string_2_hex8(Value);
	if(byt == 0x00)
	{
		printf("process cmd ET ON!\r\n");
		m_dev.dev_state = STATE_CH_ET_OPEN;
		Ciss_ble_evt_post(EVT_OPEN_ET_CH);
	}
	else
	{
		m_dev.dev_state = STATE_IDLE;
	}
}

static void at_cmd_DC(char*buf, int len)
{
	CHAR Value[5] ={0};
	UCHAR byt = 0;
	at_cmd_get_value(buf, len, 0, Value, 2);
	byt = convert_string_2_hex8(Value);
	if(byt == 0x00)
	{
		printf("process cmd DISCONNECT!\r\n");
		m_dev.dev_state = STATE_IDLE;
		Ciss_ble_evt_post(STATE_DISCONNECT);
	}
}

static void at_cmd_CF(char*buf, int len)
{
	CHAR Value[5] ={0};
	UCHAR byt = 0;
	at_cmd_get_value(buf, len, 0, Value, 2);
	byt = convert_string_2_hex8(Value);
	if(byt == 0x00)
	{
		m_dev.dev_state = STATE_SAMPLE;
		printf("process cmd START SAMPLE!\r\n");
		Ciss_ble_evt_post(EVT_START_SAMPLE);
	}

}

static void at_cmd_LS(char*buf, int len)
{
	printf("process cmd LS =%d !\r\n", len);

}

static void at_cmd_ER(char*buf, int len)
{
	printf("process cmd ER =%d !\r\n", len);
	printf("process cmd ER!\r\n");
	Ciss_ble_evt_post(EVT_CMD_ERROR);
}

static void at_cmd_PW(char*buf, int len)
{
	CHAR Value[5] ={0};
	UCHAR byt = 0;
	at_cmd_get_value(buf, len, 0, Value, 2);
	byt = convert_string_2_hex8(Value);
	if(byt == 0x00)
	{
		m_dev.dev_state = STATE_IDLE;
		printf("process cmd POWER ON!\r\n");
		Ciss_ble_evt_post(EVT_RESET);
	}
}

#define CMD_NUM (sizeof(uartCmd)/sizeof(uartCmdProcess))

static const uartCmdProcess uartCmd[] =
{
	{true, (ptr_const)"&CN=", at_cmd_CN},
	{true, (ptr_const)"&CF=", at_cmd_CF},
	{true, (ptr_const)"&IT=", at_cmd_IT},
	{true, (ptr_const)"&ET=", at_cmd_ET},
	{true, (ptr_const)"&DT=", at_cmd_DT},
	{true, (ptr_const)"&VT=", at_cmd_VT},
	{true, (ptr_const)"&DC=", at_cmd_DC},		////maybe can't use , because bypass mode
	{true, (ptr_const)"&LS=", at_cmd_LS},
	{true, (ptr_const)"&PW=", at_cmd_PW},
	{true, (ptr_const)"&ER=", at_cmd_ER},

	{false, (ptr_const)"&NC=",NULL},
};


bool Uart_frame_over(UCHAR*buf, USHORT len)
{
	USHORT i = 0;
	for(i=0; i<len; i++)
	{
		if(buf[i] == '\n')
			return true;
	}

	return false;
}


void at_command_buf_clean(void)
{
	memset(cmd_buffer, 0, CMD_BUFFER_SIZE);
	cmd_indx = 0;
}


SHORT at_command_process(CHAR* strBuf, USHORT len)
{
	int j = 0;
	struct timeval tv;

	if(strBuf[0] != '&')
		return -1;

	if(strBuf[len-1] != '\n')
		return -2;


	gettimeofday(&tv,NULL);
	m_dev.send_tim = tv.tv_sec;
	m_dev.send_tim *= 1000;
	m_dev.send_tim += tv.tv_usec/1000;

	//printf("time stamp = %ld, %d\r\n", m_dev.send_tim, m_dev.send_tim);

	for(j=0; uartCmd[j].continual==true; j++)
	{
		if(memcmp(strBuf, uartCmd[j].cmdString,4) == 0)
		{
			uartCmd[j].processer(strBuf, len);
			return 0;
		}
		else
		{
			continue;
		}
	}

	return -3;
}


static void ciss_cmd_write(UCHAR* buf, USHORT len)
{
	prvbMBPortSerialWrite(buf, len);

	printf("send cmd = %s\r\n", buf);
}

void ciss_connect_dev(UCHAR* mac)
{
	UCHAR sedBuffer[256] ={0};
	memcpy(sedBuffer, "AT+CN=", 6);
	strncat(sedBuffer, mac, 12);
	strncat(sedBuffer, "\r\n", 2);

	ciss_cmd_write(sedBuffer, strlen(sedBuffer));

}

void ciss_disconnect_dev(UCHAR* mac)
{
	UCHAR sedBuffer[256] ={0};
	memcpy(sedBuffer, "AT+DC=", 6);
	strncat(sedBuffer, mac, 12);
	strncat(sedBuffer, "\r\n", 2);

	ciss_cmd_write(sedBuffer, strlen(sedBuffer));
}

void ciss_enable_IT_dev(UCHAR* mac, bool on)
{
	UCHAR sedBuffer[256] ={0};
	memcpy(sedBuffer, "AT+IT=", 6);
	strncat(sedBuffer, mac, 12);
	if(on)
		strncat(sedBuffer, ",01\r\n", 5);
	else
		strncat(sedBuffer, ",00\r\n", 5);

	ciss_cmd_write(sedBuffer, strlen(sedBuffer));
}

void ciss_enable_ET_dev(UCHAR* mac, bool on)
{
	UCHAR sedBuffer[256] ={0};
	memcpy(sedBuffer, "AT+ET=", 6);
	strncat(sedBuffer, mac, 12);
	if(on)
		strncat(sedBuffer, ",01\r\n", 5);
	else
		strncat(sedBuffer, ",00\r\n", 5);

	ciss_cmd_write(sedBuffer, strlen(sedBuffer));
}


void ciss_enable_RESET_Module(void)
{
	UCHAR sedBuffer[256] ={0};
	memcpy(sedBuffer, "AT+RT\r\n", 7);

	ciss_cmd_write(sedBuffer, strlen(sedBuffer));
}


static void ciss_build_config_cmd(UCHAR* cmd, ULONG freq, UCHAR mode)
{
	struct timeval tv;
	UCHAR on = 0x19;
	UCHAR sensor = 0x00;
	UCHAR f = 0x02;
	UCHAR tx = 07;
	ULONG timTamp = 0;


	gettimeofday(&tv,NULL);
	timTamp = tv.tv_sec;

	if(freq == 10)
		f = 0x01;
	else if(freq == 100)
		f = 0x02;
	else if(freq == 1000)
		f = 0x03;
	else if(freq == 10000)
		f = 0x04;
	else if(freq == 30000)
		f = 0x05;
	else if(freq == 60000)
		f = 0x06;
	else if(freq == 600000)
		f = 0x07;
	else
	{
		on = 0x18;
		f = 0x03;
	}

	if(mode == 0)
	{
		on = 0x18;
		sensor = 0x00;
	}
	else
	{
		if((mode & 0x01) == 0x01)
		{
			sensor |= 0x07;
		}

		if((mode & 0x02) == 0x02)
		{
			sensor |= 0xC8;
		}
	}

	///190F02079BC7255C
	sprintf(cmd, "%.2X%.2X%.2X%.2X%.8X",on, sensor,f, tx, timTamp);
}

void ciss_enable_sample_dev(UCHAR* mac, USHORT frq, UCHAR mod)
{
	UCHAR cmdBuf[32] = {0};
	UCHAR sedBuffer[256] ={0};
	memcpy(sedBuffer, "AT+CF=", 6);
	strncat(sedBuffer, mac, 12);
	strncat(sedBuffer, ",", 1);
	ciss_build_config_cmd(cmdBuf, frq, mod);
	strncat(sedBuffer, cmdBuf, strlen(cmdBuf));
	strncat(sedBuffer, "\r\n", 2);

	ciss_cmd_write(sedBuffer, strlen(sedBuffer));
}

/*
 *
&CN=00,02891B550346
&ET=00,02891B550346
&IT=00,02891B550346
&CF=00,02891B550346
&DT=02891B550346,ff93,000b,fc0d,0000,0000,0000,0000,0000,0000
&DT=02891B550346,ff8f,0005,fc09,0000,0000,0000,05ce,3852,ff29
&DT=02891B550346,ff91,0013,fc0b,0000,0000,0000,05cb,3852,ff2a
&DT=02891B550346,ff91,0009,fbfe,0000,0000,0000,05cc,3852,ff2c
&DT=02891B550346,ff8d,000b,fc11,0000,0000,0000,05cd,3852,ff26
&DT=02891B550346,ff8b,0009,fc08,0000,0000,0000,05cd,3852,ff2b
&DT=02891B550346,ff87,000b,fc0d,0000,0000,0000,05cf,3852,ff29
&DT=02891B550346,ff8b,0013,fc0d,0000,0000,0000,05cd,3852,ff2b
&ET=02891B550346,00be,107c,00019200,00be,00019200
&DT=02891B550346,ff86,000b,fc02,0000,0000,0000,05cd,3852,ff28
&DT=02891B550346,ff91,0011,fc04,0000,0000,0000,05cf,3852,ff28
&DT=02891B550346,ff8b,000f,fc08,0000,0000,0000,05cc,3852,ff29
&DT=02891B550346,ff93,0009,fc00,0000,0000,0000,05ce,3852,ff29
&DT=02891B550346,ff89,000b,fc0b,0000,0000,0000,05cd,3852,ff29
&DT=02891B550346,ff91,0005,fc09,0000,0000,0000,05cd,3852,ff27
&DT=02891B550346,ff89,0007,fbfe,0000,0000,0000,05cc,3852,ff26
&DT=02891B550346,ff95,000b,fc00,0000,0000,0000,05cc,3852,ff26
&DT=02891B550346,ff8f,0005,fc0b,0000,0000,0000,05cd,3852,ff2c
&DT=02891B550346,ff86,000b,fc0d,0000,0000,0000,05cd,3852,ff2a
&ET=02891B550346,00bf,1077,00019200,00bf,00019200
&DT=02891B550346,ff89,000f,fc00,0000,0000,0000,05cd,3852,ff29
&DT=02891B550346,ff8f,000d,fc04,0000,0000,0000,05ce,3852,ff27
&DT=02891B550346,ff8b,0007,fc09,0000,0000,0000,05ce,3852,ff2b
&DT=02891B550346,ff8f,000b,fc0b,0000,0000,0000,05cf,3852,ff28
&DT=02891B550346,ff8b,000f,fc04,0000,0000,0000,05cd,3852,ff2a
&DT=02891B550346,ff8b,0009,fc04,0000,0000,0000,05ce,3852,ff27
&DT=02891B550346,ff87,000b,fc08,0000,0000,0000,05cd,3852,ff2d
&DT=02891B550346,ff93,0007,fc0f,0000,0000,0000,05cf,3852,ff27
&DT=02891B550346,ff93,0005,fc02,0000,0000,0000,05cd,3852,ff2b
&DT=02891B550346,ff8d,0009,fc0b,0000,0000,0000,05cd,3852,ff2a
&ET=02891B550346,00bf,1076,00019200,00bf,00019200
&DT=02891B550346,ff93,0009,fc0b,0000,0000,0000,05ce,3852,ff2c
&DT=02891B550346,ff95,000b,fc11,0000,0000,0000,05cd,3852,ff29
&DT=02891B550346,ff84,000b,fc04,0000,0000,0000,05cd,3852,ff2a
&DT=02891B550346,ff8f,000b,fc17,0000,0000,0000,05ce,3852,ff27
&CF=00,02891B550346
&DT=02891B550346,ff93,0005,fc0d,0000,0000,0000,05cd,3852,ff26
&DT=02891B550346,ff95,000d,fc02,0000,0000,0000,05cd,3852,ff2b
&DT=02891B550346,ff8b,0005,fbfe,0000,0000,0000,05ce,3852,ff2c
&DT=02891B550346,ff8f,0007,fc08,0000,0000,0000,05cc,3852,ff27
&DT=02891B550346,ff8f,0007,fc0b,0000,0000,0000,05cd,3852,ff26
&DT=02891B550346,ff8d,0005,fc09,0000,0000,0000,05cd,3852,ff2e
&ET=02891B550346,00bf,1075,00019200,00bf,00019200
&DT=02891B550346,ff87,0005,fc04,0000,0000,0000,05cd,3852,ff2b
&DT=02891B550346,ff8f,0011,fc0b,0000,0000,0000,05cb,3852,ff2a
&DT=02891B550346,ff8d,000d,fc0f,0000,0000,0000,05cc,3852,ff2a
&DT=02891B550346,ff91,000b,fc0b,0000,0000,0000,05cd,3852,ff27
&DT=02891B550346,ff87,0003,fc09,0000,0000,0000,05cd,3852,ff2a
&DT=02891B550346,ff91,000b,fc0b,0000,0000,0000,05ce,3852,ff26
&DT=02891B550346,ff8d,0007,fc04,0000,0000,0000,05cc,3852,ff28
&DT=02891B550346,ff91,0000,fc08,0000,0000,0000,05cd,3852,ff2a
&DT=02891B550346,ff8b,0005,fc08,0000,0000,0000,05cd,3852,ff29
&DT=02891B550346,ff91,0007,fc08,0000,0000,0000,05cc,3852,ff2a
&ET=02891B550346,00bf,1072,00019200,00bf,00019200
&DT=02891B550346,ff8b,0007,fc09,0000,0000,0000,05cc,3852,ff28
&DT=02891B550346,ff8d,000f,fc02,0000,0000,0000,05cf,3852,ff29
&DT=02891B550346,ff8f,000b,fc0d,0000,0000,0000,05cd,3852,ff27
&DT=02891B550346,ff87,0009,fc0d,0000,0000,0000,05cb,3852,ff28
&DT=02891B550346,ff91,000f,fc00,0000,0000,0000,05ce,3852,ff2a
&DT=02891B550346,ff89,0011,fc00,0000,0000,0000,05cc,3852,ff2a
&CF=00,02891B550346
&DT=02891B550346,ff91,0005,fc0d,0000,0000,0000,05cc,3852,ff25
&DT=02891B550346,ff8b,0005,fc09,0000,0000,0000,05cd,3852,ff27
&DT=02891B550346,ff93,000f,fc06,0000,0000,0000,05ce,3852,ff2d
&DT=02891B550346,ff84,000b,fbfe,0000,0000,0000,05cd,3852,ff26
&ET=02891B550346,00bf,1071,00019200,00bf,00019200
&DT=02891B550346,ff91,0000,fc02,0000,0000,0000,05ce,3852,ff2b
&DT=02891B550346,ff8b,0005,fc13,0000,0000,0000,05cd,3852,ff2c
&DT=02891B550346,ff89,000b,fc0b,0000,0000,0000,05ce,3852,ff29
&DT=02891B550346,ff91,000b,fc11,0000,0000,0000,05cd,3852,ff29
&DT=02891B550346,ff93,0013,fc00,0000,0000,0000,05cc,3852,ff29
&DT=02891B550346,ff8b,000b,fc04,0000,0000,0000,05cb,3852,ff2a
&DT=02891B550346,ff95,0009,fbfe,0000,0000,0000,05ce,3852,ff28
&DT=02891B550346,ff8b,000b,fc09,0000,0000,0000,05cd,3852,ff27
&DT=02891B550346,ff8f,0005,fc0d,0000,0000,0000,05ce,3852,ff29
&DT=02891B550346,ff89,0007,fc06,0000,0000,0000,05d0,3852,ff26
&ET=02891B550346,00bf,1070,00019200,00bf,00019200
&DT=02891B550346,ff97,000b,fc0d,0000,0000,0000,05ce,3852,ff2a
&DT=02891B550346,ff91,0005,fc02,0000,0000,0000,05cd,3852,ff29
&DT=02891B550346,ff80,0011,fc08,0000,0000,0000,05cd,3852,ff26
&DT=02891B550346,ff8b,0007,fc0d,0000,0000,0000,05cc,3852,ff2c
&DT=02891B550346,ff84,000b,fc02,0000,0000,0000,05cd,3852,ff27
&DT=02891B550346,ff93,0009,fc0b,0000,0000,0000,05cd,3852,ff27
&DT=02891B550346,ff8f,0013,fc08,0000,0000,0000,05cd,3852,ff2d
&DT=02891B550346,ff89,0005,fc0b,0000,0000,0000,05cf,3852,ff2a
&DT=02891B550346,ff89,000d,fc0b,0000,0000,0000,05cb,3852,ff27
&DT=02891B550346,ff8f,0007,fc00,0000,0000,0000,05cd,3852,ff2a
&ET=02891B550346,00bf,106f,00019200,00bf,00019200
&DT=02891B550346,ff8d,0009,fc00,0000,0000,0000,05cd,3852,ff2a
&DT=02891B550346,ff89,000b,fc00,0000,0000,0000,05cd,3852,ff2a
&DT=02891B550346,ff8b,0003,fc04,0000,0000,0000,05cd,3852,ff2a
&DT=02891B550346,ff8d,000b,fc0d,0000,0000,0000,05cf,3852,ff28
&DT=02891B550346,ff8f,0007,fc0b,0000,0000,0000,05cd,3852,ff2b
&DT=02891B550346,ff89,0013,fc0f,0000,0000,0000,05cd,3852,ff2f
&DT=02891B550346,ff8f,000f,fc0d,0000,0000,0000,05cf,3852,ff28
&DT=02891B550346,ff89,0001,fc0b,0000,0000,0000,05cb,3852,ff28
&DT=02891B550346,ff8f,000f,fc11,0000,0000,0000,05ce,3852,ff29
&DT=02891B550346,ff8b,000b,fc11,0000,0000,0000,05ce,3852,ff29
&CF=00,02891B550346
&DC=00,02891B550346
*/
