#include "user_config.h"

#include <unistd.h>

Ciss_config_struct m_cfg_val;

static int getValFromString(char *src, char *dst) /*nΪȣmΪλ*/
{
    char *p = src;
    char *q = dst;
    int len = strlen(src);
    int start, end;
    int i =0;
    for(i=0; i<len; i++)
    {
    	if(p[i] == ':')
    		start = i+1;
    	else if(p[i] == '*')
    		end = i;
    }

    if(start >= end)
    	return -1;

    while(start < end)
    {
    	*(q++) = p[start];
    	start++;
    }

    *(q++)='\0';

    return 0;
}

static void config_process(char* buf, USHORT len)
{

	if(strstr(buf, "CISS_NUM") != NULL)
	{
		char tbuf[32] = {0};
		getValFromString(buf, tbuf);

		m_cfg_val.ciss_num = atoi(tbuf);
		//printf("tbuf1 = %s, %d\r\n", tbuf, m_cfg_val.ciss_num);
	}
	else if(strstr(buf, "CISS_FREQ") != NULL)
	{
		char tbuf[32] = {0};
		getValFromString(buf, tbuf);

		m_cfg_val.ciss_freq = atoi(tbuf);
		//printf("freq read = %s, %d\r\n", tbuf, m_cfg_val.ciss_freq);
	}
	else if(strstr(buf, "CISS_MODE") != NULL)
	{
		char tbuf[32] = {0};
		getValFromString(buf, tbuf);

		m_cfg_val.ciss_mode = atoi(tbuf);
		//printf("tbuf3 = %s, %d\r\n", tbuf, m_cfg_val.ciss_mode);
	}
	else if(strstr(buf, "CISS_AUTO") != NULL)
	{
		char tbuf[32] = {0};
		getValFromString(buf, tbuf);

		m_cfg_val.ciss_auto = atoi(tbuf);
		//printf("tbuf4 = %s, %d\r\n", tbuf, m_cfg_val.ciss_auto);
	}
	else if(strstr(buf, "CISS_MAC") != NULL)
	{
		char tbuf[32] = {0};
		getValFromString(buf, tbuf);
		memcpy(m_cfg_val.ciss_mac, tbuf, 12);
		//printf("tbuf5 = %s, %s\r\n", tbuf, m_cfg_val.ciss_mac);
	}
	else if(strstr(buf, "CSII_PWON_DELAY") != NULL)
	{
		char tbuf[32] = {0};
		getValFromString(buf, tbuf);
		m_cfg_val.ciss_delay = atoi(tbuf);
		//printf("tbuf6 = %s, %s\r\n", tbuf, m_cfg_val.ciss_delay);
	}
	else if(strstr(buf, "GATEWAY_SN") != NULL)
	{
		char tbuf[16] ={0};
		getValFromString(buf, tbuf);
		memcpy(m_cfg_val.gw_sn, tbuf, strlen(tbuf));
		printf("gw sn = %s   !\r\n", tbuf, m_cfg_val.gw_sn);
	}
	else if(strstr(buf, "GATEWAY_MODULE") != NULL)
	{
		char tbuf[16] ={0};
		getValFromString(buf, tbuf);
		memcpy(m_cfg_val.gw_module, tbuf, strlen(tbuf));
		printf("gw module = %s   !\r\n", tbuf, m_cfg_val.gw_module);
	}



}


int config_file_read(void)
{
	FILE *fp;

	char tembuf[128] ={0};
	if ((fp = fopen("ciss_ini.cfg", "r")) == NULL)
	{
		printf("config file open failed!\r\n");
		return -1;
	}
	else
	{
		while(fgets(tembuf, 128, fp) != NULL)
		{
			//printf("read1 = %s\r\n", tembuf);
			config_process(tembuf, strlen(tembuf));
			memset(tembuf, 0, 128);
		}

		printf("ciss = %d, %d, %d, %d, %d, %s !\r\n", m_cfg_val.ciss_num
				,m_cfg_val.ciss_freq, m_cfg_val.ciss_mode, m_cfg_val.ciss_auto,
				m_cfg_val.ciss_delay, m_cfg_val.ciss_mac);

	}

	fclose(fp);
	return 0;
}

void config_file_default(void)
{
	m_cfg_val.ciss_auto = 0;
	m_cfg_val.ciss_delay = 3000;
	m_cfg_val.ciss_freq = 1000;
	m_cfg_val.ciss_mode = 1;
	m_cfg_val.ciss_num = 1;
	memcpy(m_cfg_val.ciss_mac, "02891B550346", 12);
}
